"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errorWrapper_1 = require("../../classes/errorWrapper");
exports.default = {
    generateError(message, statusCode = 400, errorCode = "misc/other") {
        return new errorWrapper_1.ErrorWrapper(message, statusCode, errorCode);
    },
    wrapError(error) {
        return new errorWrapper_1.ErrorWrapper(error.message, 500, "system-generated-error", error);
    },
    loginRequiredError() {
        return new errorWrapper_1.ErrorWrapper("Login required for this action", 401, "unauthorized");
    },
    missingParamsError() {
        return new errorWrapper_1.ErrorWrapper("Missing or invalid parameters", 500, "missing-invalid-params");
    },
    itemNotFoundError() {
        return new errorWrapper_1.ErrorWrapper("Record was not found", 404, "not-found");
    },
    badPermissionsError() {
        return new errorWrapper_1.ErrorWrapper("Insufficient permissions", 401, "not-found");
    },
};
//# sourceMappingURL=error.js.map