"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    generateErrorResponse(error) {
        var _a;
        return {
            message: error.errorMessage,
            dataType: 'string',
            data: (_a = error.errorObject) === null || _a === void 0 ? void 0 : _a.stack,
            responseType: 'errorResponse',
            statusCode: error.statusCode
        };
    },
    generateNormalResponse(dataType, data) {
        return {
            message: "OK",
            dataType: dataType,
            data: data,
            responseType: 'successResponse',
            statusCode: 200
        };
    },
    generateResponse(message, dataType, data, responseType, statusCode) {
        return {
            message: message,
            dataType: dataType,
            data: data,
            responseType: responseType,
            statusCode: statusCode
        };
    },
};
//# sourceMappingURL=response.js.map