import { DataTypes } from 'sequelize';
export declare function generateCreatedAtField(): {
    created_at: {
        type: string;
        mysqlOptions: {
            type: DataTypes.DateDataTypeConstructor;
            allowNull: boolean;
            defaultValue: import("sequelize/types/lib/utils").Literal;
            getter: (field: any) => string;
        };
    };
};
export declare function generateUpdatedAtField(): {
    updated_at: {
        type: string;
        allowNull: boolean;
        mysqlOptions: {
            type: DataTypes.DateDataTypeConstructor;
            allowNull: boolean;
            getter: (field: any) => string;
            setter: () => string;
        };
    };
};
export declare function generateIdField(): {
    id: {
        type: string;
        mysqlOptions: {
            type: DataTypes.IntegerDataTypeConstructor;
            autoIncrement: boolean;
            primaryKey: boolean;
            allowNull: boolean;
        };
        filterable: boolean;
    };
};
export declare function generateCreatedByField(service: any): {
    [x: number]: {
        allowNull: boolean;
        type: any;
        mysqlOptions: {
            allowNull: boolean;
            type: DataTypes.IntegerDataTypeConstructor;
            joinInfo: {
                type: any;
            };
        };
        addable: boolean;
        filterable: boolean;
    };
};
export declare function generateJoinableField(args: {
    name?: string;
    service: any;
    options?: object;
    mysqlOptions?: object;
    required?: boolean;
}): {
    [x: number]: {
        allowNull: boolean;
        type: any;
        mysqlOptions: {
            allowNull: boolean;
            type: DataTypes.IntegerDataTypeConstructor;
            joinInfo: {
                type: any;
            };
        };
        addable: boolean;
        filterable: boolean;
    };
};
export declare function generateEnumField(name: string, service: any, options?: object, mysqlOptions?: object): {
    [x: string]: {
        type: any;
        mysqlOptions: {
            type: DataTypes.IntegerDataTypeConstructor;
            allowNull: boolean;
        };
        resolver: (context: any, req: any, currentObject: any, query: any, args: any, parent: any) => Promise<any>;
        transform: {
            setter: (value: any) => any;
        };
        filterable: boolean;
        updateable: boolean;
        addable: boolean;
    };
};
export declare function generateBooleanField(name: string, options?: object, mysqlOptions?: object): {
    [x: string]: {
        type: string;
        mysqlOptions: {
            type: DataTypes.AbstractDataTypeConstructor;
            defaultValue: boolean;
            allowNull: boolean;
        };
        transform: {
            getter: (value: any) => boolean;
        };
        addable: boolean;
        updateable: boolean;
    };
};
export declare function generatePaginatorArgs(service: any, excludeProperties?: Array<string>): {
    id: {
        type: string;
    };
    first: {
        type: string;
    };
    after: {
        type: string;
    };
    search: {
        type: string;
    };
    sortBy: {
        type: string[];
    };
    sortDesc: {
        type: string[];
    };
};
