"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const response_1 = require("../tier0/response");
const errorWrapper_1 = require("../../classes/errorWrapper");
exports.default = {
    externalFnWrapper(externalFn) {
        return async function (req, res) {
            try {
                const responseObject = response_1.default.generateNormalResponse("object", await externalFn(req));
                res.header("Content-Type", "application/json");
                res.status(responseObject.statusCode || 200).send(responseObject);
            }
            catch (err) {
                console.log(err);
                //if not a wrapped error, wrap it        
                const errorResponseObject = response_1.default.generateErrorResponse((err instanceof errorWrapper_1.ErrorWrapper) ? err : new errorWrapper_1.ErrorWrapper(err.message, 500, "system-generated-error", err));
                return res.status(errorResponseObject.statusCode).send(errorResponseObject);
            }
        };
    }
};
//# sourceMappingURL=router.js.map