"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const jql_1 = require("../helpers/tier0/jql");
//import firestoreHelper from '../tier1/firestore';
const firestoreHelper = {};
class default_1 {
    static async resolveTableRows(context, req, jqlQuery, args = {}) {
        //validate graphql
        const validatedGraphql = jql_1.default.validateJsonqlQuery(jqlQuery.select, context.__typename);
        jqlQuery.select = validatedGraphql.validatedQuery;
        //fetch the firestore record
        const data = await firestoreHelper.db.collection(context.__typename).doc(args.id + "").get().then(res => res.data());
        //if not found, return empty array
        if (!data) {
            return [];
        }
        //put the requested fields into results
        const results = {
            __typename: context.__typename
        };
        for (const field in data) {
            if (field in validatedGraphql.validatedQuery || field in validatedGraphql.validatedResolvedQuery) {
                results[field] = data[field];
            }
        }
        const returnArray = [results];
        //handle resolved fields
        for (const returnObject of returnArray) {
            await jql_1.default.handleResolvedQueries(returnObject, validatedGraphql.validatedResolvedQuery, context, req, args);
        }
        //handle aggregated fields
        await jql_1.default.handleAggregatedQueries(returnArray, validatedGraphql.validatedAggregatedQuery, context, req, args);
        return returnArray;
    }
}
exports.default = default_1;
;
//# sourceMappingURL=primitiveResolver.js.map