"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveTableRows = void 0;
const jql_1 = require("../helpers/tier0/jql");
async function resolveTableRows(context, req, jqlQuery, args = {}, typeDef = {}) {
    //validate graphql
    const validatedGraphql = jql_1.default.validateJsonqlQuery(jqlQuery.select, null, typeDef);
    const data = {};
    //put the requested fields into results
    const results = {
        __typename: context.__typename
    };
    for (const field in data) {
        if (field in validatedGraphql.validatedQuery || field in validatedGraphql.validatedResolvedQuery) {
            results[field] = data[field];
        }
    }
    const returnArray = [results];
    //handle resolved fields
    for (const returnObject of returnArray) {
        await jql_1.default.handleResolvedQueries(returnObject, validatedGraphql.validatedResolvedQuery, context, req, args);
    }
    //handle aggregated fields
    await jql_1.default.handleAggregatedQueries(returnArray, validatedGraphql.validatedAggregatedQuery, context, req, args);
    return returnArray;
}
exports.resolveTableRows = resolveTableRows;
//# sourceMappingURL=virtualResolver.js.map