import { Service } from '../service';
export declare function generateAccessorService(service: any): {
    new (): {};
    __typename: string;
    presets: {
        default: {
            accessorInfo: {
                sufficientPermissions: null;
            };
            data: null;
        };
    };
    hasKeys: boolean;
    getTypeDef: typeof Service.getTypeDef;
    getRecord: typeof Service.getRecord;
    paginator?: Service | undefined;
    filterFieldsMap: Object;
    filterFieldsKeyMap: Object;
    sortFieldsMap: Object;
    groupByFieldsMap: Object;
    searchFieldsMap: Object;
    isFilterRequired: Boolean;
    permissionsLink?: any;
    accessControl?: {
        get?: Function | undefined;
        getMultiple?: Function | undefined;
        create?: Function | undefined;
        update?: Function | undefined;
        delete?: Function | undefined;
    } | undefined;
    generatePaginatorService: typeof import("./paginator").generatePaginatorService;
    generateAccessorService: typeof generateAccessorService;
    testPermissions(operation: string, req: any, args: any, query: any): Promise<any>;
    subscribeToSingleItem(operationName: string, req: any, args: any, query?: object | undefined, admin?: boolean): Promise<{
        channel_name: string;
    }>;
    subscribeToMultipleItem(operationName: string, req: any, args: any, query?: object | undefined, admin?: boolean): Promise<{
        channel_name: string;
    }>;
    getRecords(req: any, args?: any, query?: object | undefined, count?: boolean, admin?: boolean): Promise<any>;
    createRecord(req: any, args?: any, query?: object | undefined, admin?: boolean): Promise<any>;
    updateRecord(req: any, args?: any, query?: object | undefined): Promise<any>;
    deleteRecord(req: any, args?: any, query?: object | undefined): Promise<any>;
};
export declare function generateAccessorTypeDef(service: any): {
    accessorInfo: {
        type: string;
        resolver: (context: any, req: any, currentObject: any, query: any, args: any) => Promise<{
            __typename: any;
        }>;
    };
    data: {
        type: any[];
        resolver: (context: any, req: any, currentObject: any, query: any, args: any) => Promise<any>;
    };
};
