"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateAccessorTypeDef = exports.generateAccessorService = void 0;
const service_1 = require("../service");
const accessorInfo_1 = require("./accessorInfo");
const error_1 = require("../../helpers/tier0/error");
function generateAccessorService(service) {
    var _a;
    return _a = class extends service_1.Service {
        },
        _a.__typename = service.__typename + 'Accessor',
        _a.presets = {
            default: {
                accessorInfo: {
                    sufficientPermissions: null,
                },
                data: null
            }
        },
        _a.hasKeys = false,
        _a.getTypeDef = service_1.Service.getTypeDef,
        _a.getRecord = service_1.Service.getRecord,
        _a;
}
exports.generateAccessorService = generateAccessorService;
function generateAccessorTypeDef(service) {
    const AccessorInfo = accessorInfo_1.generateAccessorInfoService(service);
    return {
        accessorInfo: {
            type: AccessorInfo.__typename,
            resolver: async (context, req, currentObject, query, args) => {
                return AccessorInfo.getRecord(req, Object.assign({}, args), query);
            },
        },
        data: {
            type: [service.__typename],
            resolver: async (context, req, currentObject, query, args) => {
                try {
                    //if it does not pass the access control, throw an error
                    if (!await service.testPermissions('get', req)) {
                        throw error_1.default.badPermissionsError();
                    }
                    const results = await service.getRecord(req, Object.assign({}, args), query);
                    return results;
                }
                catch (err) {
                    return null;
                }
            }
        },
    };
}
exports.generateAccessorTypeDef = generateAccessorTypeDef;
;
//# sourceMappingURL=accessor.js.map