"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateAccessorInfoTypeDef = exports.generateAccessorInfoService = void 0;
const service_1 = require("../service");
const resolverHelper = require("../../resolvers/virtualResolver");
const error_1 = require("../../helpers/tier0/error");
const dataType_1 = require("../../helpers/tier0/dataType");
function generateAccessorInfoService(service) {
    var _a;
    return _a = class extends service_1.Service {
            static async getRecord(req, args, query) {
                const results = await resolverHelper.resolveTableRows(this, req, { select: query }, args, generateAccessorInfoTypeDef(service));
                if (results.length < 1) {
                    throw error_1.default.itemNotFoundError();
                }
                return results[0];
            }
        },
        _a.__typename = 'accessorInfo',
        _a.presets = {
            default: {
                total: null
            }
        },
        _a.hasKeys = false,
        _a;
}
exports.generateAccessorInfoService = generateAccessorInfoService;
function generateAccessorInfoTypeDef(service = {}) {
    return {
        permissions: {
            type: dataType_1.dataTypes.STRING,
            resolver: async (context, req, currentObject, query, args) => {
                return service.getRecords(req, Object.assign({}, args), null, true);
            }
        },
        sufficientPermissions: {
            type: dataType_1.dataTypes.BOOLEAN,
            resolver: async (context, req, currentObject, query, args) => {
                return service.testPermissions('get', req);
            }
        }
    };
}
exports.generateAccessorInfoTypeDef = generateAccessorInfoTypeDef;
;
//# sourceMappingURL=accessorInfo.js.map