import { Service } from '../service';
export declare function generateEnumService(enumName: string, currentEnum: object): {
    new (): {};
    __typename: string;
    presets: {
        default: {
            id: null;
            name: null;
        };
    };
    enum: object;
    getTypeDef: typeof Service.getTypeDef;
    getRecord: typeof Service.getRecord;
    paginator?: Service | undefined;
    filterFieldsMap: Object;
    filterFieldsKeyMap: Object;
    hasKeys: Boolean;
    sortFieldsMap: Object;
    groupByFieldsMap: Object;
    searchFieldsMap: Object;
    isFilterRequired: Boolean;
    permissionsLink?: any;
    accessControl?: {
        get?: Function | undefined;
        getMultiple?: Function | undefined;
        create?: Function | undefined;
        update?: Function | undefined;
        delete?: Function | undefined;
    } | undefined;
    generatePaginatorService: typeof import("./paginator").generatePaginatorService;
    generateAccessorService: typeof import("./accessor").generateAccessorService;
    testPermissions(operation: string, req: any, args: any, query: any): Promise<any>;
    subscribeToSingleItem(operationName: string, req: any, args: any, query?: object | undefined, admin?: boolean): Promise<{
        channel_name: string;
    }>;
    subscribeToMultipleItem(operationName: string, req: any, args: any, query?: object | undefined, admin?: boolean): Promise<{
        channel_name: string;
    }>;
    getRecords(req: any, args?: any, query?: object | undefined, count?: boolean, admin?: boolean): Promise<any>;
    createRecord(req: any, args?: any, query?: object | undefined, admin?: boolean): Promise<any>;
    updateRecord(req: any, args?: any, query?: object | undefined): Promise<any>;
    deleteRecord(req: any, args?: any, query?: object | undefined): Promise<any>;
};
export declare function generateEnumTypeDef(currentEnum: object): {
    id: {
        type: string;
        resolver: (context: any, req: any, currentObject: any, query: any, args: any) => Promise<any>;
    };
    name: {
        type: string;
        resolver: (context: any, req: any, currentObject: any, query: any, args: any) => Promise<any>;
    };
};
