"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateEnumTypeDef = exports.generateEnumService = void 0;
const service_1 = require("../service");
const dataType_1 = require("../../helpers/tier0/dataType");
function generateEnumService(enumName, currentEnum) {
    var _a;
    return _a = class extends service_1.Service {
        },
        _a.__typename = enumName + 'Enum',
        _a.presets = {
            default: {
                id: null,
                name: null,
            }
        },
        _a.enum = currentEnum,
        _a.getTypeDef = service_1.Service.getTypeDef,
        _a.getRecord = service_1.Service.getRecord,
        _a;
}
exports.generateEnumService = generateEnumService;
function generateEnumTypeDef(currentEnum) {
    return {
        id: {
            type: dataType_1.dataTypes.ID,
            resolver: async (context, req, currentObject, query, args) => {
                return args.id;
            }
        },
        name: {
            type: dataType_1.dataTypes.STRING,
            resolver: async (context, req, currentObject, query, args) => {
                return currentEnum[args.id];
            }
        }
    };
}
exports.generateEnumTypeDef = generateEnumTypeDef;
;
//# sourceMappingURL=enum.js.map