"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generatePaginatorInfoTypeDef = exports.generatePaginatorInfoService = void 0;
const service_1 = require("../service");
const resolverHelper = require("../../resolvers/virtualResolver");
const error_1 = require("../../helpers/tier0/error");
const dataType_1 = require("../../helpers/tier0/dataType");
function generatePaginatorInfoService(service) {
    var _a;
    return _a = class extends service_1.Service {
            static async getRecord(req, args, query) {
                const results = await resolverHelper.resolveTableRows(this, req, { select: query }, args, generatePaginatorInfoTypeDef(service));
                if (results.length < 1) {
                    throw error_1.default.itemNotFoundError();
                }
                return results[0];
            }
        },
        _a.__typename = 'paginatorInfo',
        _a.presets = {
            default: {
                total: null
            }
        },
        _a.hasKeys = false,
        _a;
}
exports.generatePaginatorInfoService = generatePaginatorInfoService;
function generatePaginatorInfoTypeDef(service = {}) {
    return {
        total: {
            type: dataType_1.dataTypes.INTEGER,
            resolver: async (context, req, currentObject, query, args) => {
                return service.getRecords(req, Object.assign(Object.assign({}, args), { after: null }), null, true);
            }
        },
        count: {
            type: dataType_1.dataTypes.INTEGER,
            resolver: async (context, req, currentObject, query, args) => {
                return Math.min(args.first || Infinity, await service.getRecords(req, Object.assign({}, args), null, true));
            }
        },
    };
}
exports.generatePaginatorInfoTypeDef = generatePaginatorInfoTypeDef;
;
//# sourceMappingURL=paginatorInfo.js.map