import { generatePaginatorService, generateAccessorService } from './generators';
export declare abstract class Service {
    static __typename: string;
    static paginator?: Service;
    static presets: {
        default: Object;
    };
    static filterFieldsMap: Object;
    static filterFieldsKeyMap: Object;
    static hasKeys: Boolean;
    static sortFieldsMap: Object;
    static groupByFieldsMap: Object;
    static searchFieldsMap: Object;
    static isFilterRequired: Boolean;
    static permissionsLink?: any;
    static accessControl?: {
        get?: Function;
        getMultiple?: Function;
        create?: Function;
        update?: Function;
        delete?: Function;
    };
    static getTypeDef(): any;
    static generatePaginatorService: typeof generatePaginatorService;
    static generateAccessorService: typeof generateAccessorService;
    static testPermissions(operation: string, req: any, args: any, query: any): Promise<any>;
    static subscribeToSingleItem(operationName: string, req: any, args: any, query?: object, admin?: boolean): Promise<{
        channel_name: string;
    }>;
    static subscribeToMultipleItem(operationName: string, req: any, args: any, query?: object, admin?: boolean): Promise<{
        channel_name: string;
    }>;
    static getRecord(req: any, args?: any, query?: object, count?: boolean, admin?: boolean): Promise<any>;
    static getRecords(req: any, args?: any, query?: object, count?: boolean, admin?: boolean): Promise<any>;
    static createRecord(req: any, args?: any, query?: object, admin?: boolean): Promise<any>;
    static updateRecord(req: any, args?: any, query?: object): Promise<any>;
    static deleteRecord(req: any, args?: any, query?: object): Promise<any>;
}
